//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		GenTemp.cpp
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		۸т'create'°قɂĎgp`Ԑݒ̧ٗp̐`
//				𐶐܂B
//
//				3̕sKȌAsKȎ[AsKȏ޸܂B
//				Ұ͖Ȃ܂܂łB
//
// ̑:
//=============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

//=============================================================================
// ɕ\钘쌠

char *copyrightString =
	"\ngentemp v1.0 - Copyright (C) 2003 Atmel Corporation\n\n";

//=============================================================================
// S^Ȃꍇɕ\g

char *usageString =
	"Usage: gentemp <filename>\n\n";

//=============================================================================
// Aǂèꂽ޲Ă𐶐

void generateRandomParityCheckedBytes(unsigned char *destination, int size)
{
	while (size--)
	{
		unsigned char byte = rand() & 0xfe;
		unsigned char parity = byte;

		parity ^= parity >> 4;
		parity ^= parity >> 2;
		parity ^= parity >> 1;

		*destination++ = byte | (~parity & 0x01);
	}
}

//=============================================================================
// ޲Đ

void generateRandomBytes(unsigned char *destination, int size)
{
	while (size--)
		*destination++ = rand();
}

//=============================================================================
// ޲Ă16iɕϊ

char *bytesToHexString(char *string, unsigned char *bytes, int size)
{
	int index = 0;

	while (size--)
	{
		int value = *bytes++;

		sprintf(&string[index], "%02X", value);
		index += 2;
	}

	return string;
}

//=============================================================================
// AŎn܂܂!

int main(int argc, char* argv[])
{
	printf(copyrightString);

	// ݂̎ԂɊÂė̎I
	srand((unsigned)time(NULL));

	// ŏ̖ߍs(۸т̖O܂ޕ)΂B
	argv++;
	argc--;

	// S^ȂꍇɎg\
	if (argc == 0 || argc > 1)
	{
		printf(usageString);
		return -1;
	}

	char *filename = argv[0];
	FILE *outputFile = NULL;

	if (outputFile = fopen(filename, "w"))
	{
		unsigned char tempBytes[8];
		char tempString[17];

		fprintf(outputFile,
			"PAGE_SIZE      = [FILL IN: Target AVR page size in bytes]\n");
		fprintf(outputFile,
			"MEM_SIZE       = [FILL IN: Application Section size in bytes]\n");
		fprintf(outputFile,
			"CRC_ENABLE     = [FILL IN: YES/NO]\n");

		generateRandomParityCheckedBytes(tempBytes, 8);
		fprintf(outputFile, "KEY1           = %s\n",
			bytesToHexString(tempString, tempBytes, 8)
		);

		generateRandomParityCheckedBytes(tempBytes, 8);
		fprintf(outputFile, "KEY2           = %s\n",
			bytesToHexString(tempString, tempBytes, 8)
		);

		generateRandomParityCheckedBytes(tempBytes, 8);
		fprintf(outputFile, "KEY3           = %s\n",
			bytesToHexString(tempString, tempBytes, 8)
		);

		generateRandomBytes(tempBytes, 8);
		fprintf(outputFile, "INITIAL_VECTOR = %s\n",
			bytesToHexString(tempString, tempBytes, 8)
		);

		generateRandomBytes(tempBytes, 4);
		fprintf(outputFile, "SIGNATURE      = %s\n",
			bytesToHexString(tempString, tempBytes, 4)
		);

		printf("%s generated.\n", filename);

		fclose(outputFile);
		return 0;
	}
	else
	{
		printf("Error: Couldn't create file %s.", filename);
		return -1;
	}
}
