//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		usart.c
// ߲:		IAR Atmel AVR C/EC++߲
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		USART interface.
//
// ̑:
//=============================================================================

#include <inavr.h>
#include <ioavr.h>
#include "bus.h"

//=============================================================================
// ޽ ̪

void busInit(void)
{
	// 9600ް/8.00MHz
	UBRRL = 51;

	// M
	UCSRB = (1 << RXEN) | (1 << TXEN);
}

//=============================================================================
// ޽(̏ꍇAŏ޲ēҋ@)

void busPrepare(void)
{
	while (!(UCSRA & (1 << RXC)));
}

//=============================================================================
// ޲ĕԓ

void busReplyByte(unsigned char data)
{
	while (!(UCSRA & (1 << UDRE)));
	UDR = data;
}

//=============================================================================
// ޲ĎM

unsigned char busReceiveByte(void)
{
	busPrepare();

	return UDR;
}

//=============================================================================
// ޽𑽖ZԂɐݒBUSARTł̊KvB

void busBusy(void)
{
	return;
}
