//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		usart0.c
// ߲:		IAR Atmel AVR C/EC++߲
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		USART̪
//
// ̑:
//=============================================================================

#include <inavr.h>
#include <ioavr.h>
#include "bus.h"

//=============================================================================
// ޽ ̪

void busInit(void)
{
	// 9600ް/8.00MHz
	UBRR0L = 51;

	// M
	UCSR0B = (1 << RXEN0) + (1 << TXEN0);
}

//=============================================================================
// ޽(̏ꍇAŏ޲ēҋ@)

void busPrepare(void)
{
	while (!(UCSR0A & (1 << RXC0)));
}

//=============================================================================
// ޲ĎM

unsigned char busReceiveByte(void)
{
	busPrepare();

	return UDR0;
}

//=============================================================================
// ޽𑽖ZԂɐݒBUSARTł̊KvB

void busBusy(void)
{
	return;
}

//=============================================================================
// ޲ĕԓ

void busReplyByte(unsigned char data)
{
	while(!(UCSR0A & (1 << UDRE0)));
	UDR0 = data;
}
